import java.util.Arrays;

public class MyArrayList<E> {

    protected int size;
    protected Object[] elements;

    public MyArrayList() {
        elements = new Object[10];
        size = 0;
    }

    public int size() {
        return size;
    }

    public void add(E e){
        if (size < elements.length) {
            elements[size] = e;
        } else {
            elements = Arrays.copyOf(elements, size);
        }
        ++size;
    }

    public void set(int index, E e) {
        for (int i = 0; i < elements.length; i++)
            elements[i] = index;
        elements[index] = e;
    }

    public E get(int index) {
        if (index >= size)
            throw new IndexOutOfBoundsException("Index: " + index + ", Size: " + size);
        return (E) elements[index];
    }

    public void clear() {
        if (size > 0) elements[size] = 0;
    }

    public boolean isEmpty() {
        if (size == 0) {
            return true;
        }
        return false;
    }

    public boolean contains(E e) {
        for (Object o : elements)
            if (o != null && o.equals(e)) {
                return true;
            }
        return false;
    }

    public E remove(int index) {
        E temp = null;
        for (int i = 0; i < elements.length - 1; i++) {
            if (i == index) {
                temp = (E) elements[i];
                elements[i] = elements[i + 1];
            }
                elements[i] = elements[i + 1];
                elements[elements.length - 2] = elements[elements.length - 1];
            }
        return temp;
    }

    public int indexOf(E e) {
        int x = 0;
        for (int i = 0; i < elements.length - 1; i++) {
            if (elements[i].equals(e)) {
                x = i;
            }
        }
        return x;
    }
}

